const int Num = 4;  // Numero letture ADC

// Motori
const int Pin_OUT_L = 5;     // PWM Motore sinistro
const int Pin_OUT_R = 3;     // PWM Motore destro

// Sensori
#define AND 0
#define MOR 1
#define LUC 0
#define MIC 0

#if AND == 1
const int sharpL_pin = A1;   // SHARP SINISTRO
const int sharpR_pin = A0;   // SHARP DESTRO
const int battery_pin = A2;  // Batteria
const int cny70L_pin = A5;    // CNY70 SINISTRO
const int cny70R_pin = A4;    // CNY70 DESTRO
const float sVL = 1.275;
const float sVR = 1;
#elif MOR == 1 //??????????????????
const int sharpL_pin = A1;   // SHARP SINISTRO
const int sharpR_pin = A0;   // SHARP DESTRO
const int battery_pin = A2;  // Batteria
const int cny70L_pin = A5;    // CNY70 SINISTRO
const int cny70R_pin = A4;    // CNY70 DESTRO
const float sVL = 1.2;
const float sVR = 1;
#elif LUC == 1
const int sharpL_pin = A2;   // SHARP SINISTRO
const int sharpR_pin = A3;   // SHARP DESTRO
const int battery_pin = A0;  // Batteria
const int cny70L_pin = A1;    // CNY70 SINISTRO
const int cny70R_pin = A4;    // CNY70 DESTRO
const float sVL = 1.25;
const float sVR = 1;
#elif MIC == 1
const int sharpL_pin = A4;   // SHARP SINISTRO
const int sharpR_pin = A5;   // SHARP DESTRO
const int battery_pin = A0;  // Batteria
const int cny70L_pin = A2;    // CNY70 SINISTRO
const int cny70R_pin = A1;    // CNY70 DESTRO
const float sVL = 1.1;
const float sVR = 1;
#endif

const int B = 0;   // Bianco
const int N = 1;   // Nero
const int L = -1;  // Left
const int R = 1;   // Right

const int Vmax0 = 100; //100
const int Vmed0 = 55; //50
const int Vmin0 = 35; //50
int Vmax = Vmax0;
int Vmed = Vmed0;
int Vmin = Vmin0;
int VL = Vmed0;
int VR = Vmed0;

const int dV = 0; //-10
const int dist = 100;   // Distanza minima
const int max_battery = 800; // Valore letto dall'ADC a batterie nuove
const int soglia = 300;   // soglia B-N

int val_cny70L = B;
int val_cny70R = B;
int val_cny70L_pre = B;
int val_cny70R_pre = B;
int Aval_cny70L = 0;
int Aval_cny70R = 0;
int val_sharpL = 0;
int val_sharpR = 0;
int val_battery = 0;

int dir = 0;

unsigned long now, nextBatt, nextMap;

float Zk = 0.3;

boolean cir = true;

void setup() {                
  pinMode(Pin_OUT_L, OUTPUT);  
  pinMode(Pin_OUT_R, OUTPUT);
  
  nextBatt = millis();
  
  //Serial.begin(115200);
}

// the loop routine runs over and over again forever:
void loop()
{
  // Controllo carica batteria
  now = millis();
  if (now > nextBatt) {
    nextBatt = now + 60000;
        
    val_battery = 0;
    for (int j = 0; j < Num; j++) {
      val_battery += analogRead(battery_pin);
      delayMicroseconds(100);
    }
    val_battery /= Num;  
    
    Vmin = float(Vmin0) * float(max_battery) / float(val_battery);
    Vmed = float(Vmed0) * float(max_battery) / float(val_battery);
    Vmax = float(Vmax0) * float(max_battery) / float(val_battery);
    
    /*Serial.print("Vmed = ");
    Serial.print(Vmed);
    Serial.print(" Vme = ");
    Serial.print(Vme);
    Serial.print(" Vmax = ");
    Serial.print(Vmax);
    Serial.print(" Vma = ");
    Serial.println(Vma);*/
  }
 
  // Mappa Logistica
  now = millis();
  if (now > nextMap) {
    nextMap = now + 20000;

    Zk = 4.0*Zk*(1 - Zk);

    if (cir) {
      VL = Vmed;
      VR = Vmin;
    }
    else {
      VL = Vmin;
      VR = Vmed;
    }
    cir = !cir;
  }

  analogWrite(Pin_OUT_L, VL*sVL);
  analogWrite(Pin_OUT_R, VR*sVR);
    
  // Lettura valori dai sensori
  val_sharpL = val_sharpR = Aval_cny70L = Aval_cny70R = 0;
  for (int j = 0; j < Num; j++) {
    val_sharpL += analogRead(sharpL_pin);
    delayMicroseconds(100);
    val_sharpR += analogRead(sharpR_pin);
    delayMicroseconds(100);
    Aval_cny70L += analogRead(cny70L_pin);
    delayMicroseconds(100);
    Aval_cny70R += analogRead(cny70R_pin);
    delayMicroseconds(100);
  }
  val_sharpL /= Num;
  val_sharpR /= Num;
  Aval_cny70L /= Num;
  Aval_cny70R /= Num;
  
  // ========================================================================
  // ==========  conversione soglia bianco/vero cny70 su analogico ==========
  // ========================================================================
  if (Aval_cny70L > soglia){val_cny70L=B;}
  else {val_cny70L=N;}
  if (Aval_cny70R > soglia){val_cny70R=B;}
  else {val_cny70R=N;}

  delay(1);

//  Serial.print("SHARP Left: ");
//  Serial.print(val_sharpL);
//
//  Serial.print(" - Right: ");
//  Serial.print(val_sharpR);
//  
//  Serial.print(" || CNY70 Left: ");
//  Serial.print(Aval_cny70L);
//  Serial.print(" ");
//  Serial.print(val_cny70L);
//  
//  Serial.print(" - Right: ");
//  Serial.print(Aval_cny70R);    
//  Serial.print(" ");
//  Serial.print(val_cny70R);
//   
//  Serial.println();  // print the distance
}

